Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2920)
@@ -6539,12 +6457,457 @@
 
     END SUBROUTINE raytrace
-
-
+    
+ 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Determines whether two faces are oriented towards each other. Since the 
-!> surfaces follow the gird box surfaces, it checks first whether the two surfaces 
-!> are directed in the same direction, then it checks if the two surfaces are     
+!> A new, more efficient version of ray tracing algorithm that processes a whole
+!> arc instead of a single ray.
+!>
+!> In all comments, horizon means tangent of horizon angle, i.e.
+!> vertical_delta / horizontal_distance
+!------------------------------------------------------------------------------!
+   SUBROUTINE raytrace_2d(origin, yxdir, zdirs, iorig, aorig, vffrac, &
+                              create_csf, skip_1st_pcb, win_lad, horizon, &
+                              transparency)
+      IMPLICIT NONE
+
+      REAL(wp), DIMENSION(3), INTENT(IN)     ::  origin        !< z,y,x coordinates of ray origin
+      REAL(wp), DIMENSION(2), INTENT(IN)     ::  yxdir         !< y,x *unit* vector of ray direction (in grid units)
+      REAL(wp), DIMENSION(:), INTENT(IN)     ::  zdirs         !< list of z directions to raytrace (z/hdist, in grid)
+      INTEGER(iwp), INTENT(in)               ::  iorig         !< index of origin face for csf
+      REAL(wp), INTENT(in)                   ::  aorig         !< origin face area for csf
+      REAL(wp), DIMENSION(LBOUND(zdirs, 1):UBOUND(zdirs, 1)), INTENT(in) ::  vffrac !< 
+                                                               !< view factor fractions of each ray for csf
+      LOGICAL, INTENT(in)                    ::  create_csf    !< whether to generate new CSFs during raytracing
+      LOGICAL, INTENT(in)                    ::  skip_1st_pcb  !< whether to skip first plant canopy box during raytracing
+      INTEGER(iwp), INTENT(in)               ::  win_lad       !< leaf area density MPI window
+      REAL(wp), INTENT(OUT)                  ::  horizon       !< highest horizon found after raytracing (z/hdist)
+      REAL(wp), DIMENSION(LBOUND(zdirs, 1):UBOUND(zdirs, 1)), INTENT(OUT) ::  transparency !<
+                                                                !< transparencies of zdirs paths
+      !--INTEGER(iwp), DIMENSION(3, LBOUND(zdirs, 1):UBOUND(zdirs, 1)), INTENT(OUT) :: itarget !<
+                                                                !< (z,y,x) coordinates of target faces for zdirs
+      INTEGER(iwp)                           ::  i, k, l, d
+      INTEGER(iwp)                           ::  seldim       !< dimension to be incremented
+      REAL(wp), DIMENSION(2)                 ::  yxorigin     !< horizontal copy of origin (y,x)
+      REAL(wp)                               ::  distance     !< euclidean along path
+      REAL(wp)                               ::  lastdist     !< beginning of current crossing
+      REAL(wp)                               ::  nextdist     !< end of current crossing
+      REAL(wp)                               ::  crmid        !< midpoint of crossing
+      REAL(wp)                               ::  horz_entry   !< horizon at entry to column
+      REAL(wp)                               ::  horz_exit    !< horizon at exit from column
+      REAL(wp)                               ::  bdydim       !< boundary for current dimension
+      REAL(wp), DIMENSION(2)                 ::  crossdist    !< distances to boundary for dimensions
+      REAL(wp), DIMENSION(2)                 ::  dimnextdist  !< distance for each dimension increments
+      INTEGER(iwp), DIMENSION(2)             ::  column       !< grid column being crossed
+      INTEGER(iwp), DIMENSION(2)             ::  dimnext      !< next dimension increments along path
+      INTEGER(iwp), DIMENSION(2)             ::  dimdelta     !< dimension direction = +- 1
+      INTEGER(iwp)                           ::  px, py       !< number of processors in x and y dir before 
+                                                              !< the processor in the question
+      INTEGER(iwp)                           ::  ip           !< number of processor where gridbox reside
+      INTEGER(iwp)                           ::  ig           !< 1D index of gridbox in global 2D array
+      INTEGER(MPI_ADDRESS_KIND)              ::  wdisp        !< RMA window displacement
+      INTEGER(iwp)                           ::  wcount       !< RMA window item count
+      INTEGER(iwp)                           ::  maxboxes     !< max no of CSF created
+      INTEGER(iwp)                           ::  nly          !< maximum  plant canopy height 
+      INTEGER(iwp)                           ::  ntrack
+      REAL(wp)                               ::  zbottom, ztop !< urban surface boundary in real numbers
+      REAL(wp)                               ::  zorig        !< z coordinate of ray column entry
+      REAL(wp)                               ::  zexit        !< z coordinate of ray column exit
+      REAL(wp)                               ::  qdist        !< ratio of real distance to z coord difference
+      REAL(wp)                               ::  dxxyy        !< square of real horizontal distance
+      REAL(wp)                               ::  curtrans     !< transparency of current PC box crossing
+      INTEGER(iwp)                           ::  zb0
+      INTEGER(iwp)                           ::  zb1
+      INTEGER(iwp)                           ::  nz
+      INTEGER(iwp)                           ::  iz
+      INTEGER(iwp)                           ::  zsgn
+      REAL(wp), PARAMETER                    ::  grow_factor = 1.5_wp !< factor of expansion of grow arrays
+
+      
+      yxorigin(:) = origin(2:3)
+      transparency(:) = 1._wp !-- Pre-set the all rays to transparent before reducing
+      horizon = -HUGE(1._wp)
+
+      !--Determine distance to boundary (in 2D xy)
+      IF ( yxdir(1) > 0._wp )  THEN
+         bdydim = ny + .5_wp !< north global boundary
+         crossdist(1) = (bdydim - yxorigin(1)) / yxdir(1)
+      ELSEIF ( yxdir(1) == 0._wp )  THEN
+         crossdist(1) = HUGE(1._wp)
+      ELSE
+          bdydim = -.5_wp !< south global boundary
+          crossdist(1) = (bdydim - yxorigin(1)) / yxdir(1)
+      ENDIF
+
+      IF ( yxdir(2) >= 0._wp )  THEN
+          bdydim = nx + .5_wp !< east global boundary
+          crossdist(2) = (bdydim - yxorigin(2)) / yxdir(2)
+      ELSEIF ( yxdir(2) == 0._wp )  THEN
+         crossdist(2) = HUGE(1._wp)
+      ELSE
+          bdydim = -.5_wp !< west global boundary
+          crossdist(2) = (bdydim - yxorigin(2)) / yxdir(2)
+      ENDIF
+      distance = minval(crossdist, 1)
+
+      IF ( plant_canopy )  THEN
+         rt2_track_dist(0) = 0._wp
+         rt2_track_lad(:,:) = 0._wp
+         nly = plantt_max - nzub + 1
+      ENDIF
+
+      lastdist = 0._wp
+
+!--   Since all face coordinates have values *.5 and we'd like to use
+!--   integers, all these have .5 added
+      DO d = 1, 2
+          IF ( yxdir(d) == 0._wp )  THEN
+              dimnext(d) = HUGE(1_iwp)
+              dimdelta(d) = HUGE(1_iwp)
+              dimnextdist(d) = HUGE(1._wp)
+          ELSE IF ( yxdir(d) > 0._wp )  THEN
+              dimnext(d) = FLOOR(yxorigin(d) + .5_wp) + 1
+              dimdelta(d) = 1
+              dimnextdist(d) = (dimnext(d) - .5_wp - yxorigin(d)) / yxdir(d)
+          ELSE
+              dimnext(d) = CEILING(yxorigin(d) + .5_wp) - 1
+              dimdelta(d) = -1
+              dimnextdist(d) = (dimnext(d) - .5_wp - yxorigin(d)) / yxdir(d)
+          ENDIF
+      ENDDO
+
+      ntrack = 0
+      DO
+!--      along what dimension will the next wall crossing be?
+         seldim = minloc(dimnextdist, 1)
+         nextdist = dimnextdist(seldim)
+         IF ( nextdist > distance ) nextdist = distance
+
+         IF ( nextdist > lastdist )  THEN
+            ntrack = ntrack + 1
+            crmid = (lastdist + nextdist) * .5_wp
+            column = NINT(yxorigin(:) + yxdir(:) * crmid, iwp)
+
+!--         calculate index of the grid with global indices (column(1),column(2))
+!--         in the array nzterr and plantt and id of the coresponding processor
+            px = column(2)/nnx
+            py = column(1)/nny
+            ip = px*pdims(2)+py
+            ig = ip*nnx*nny + (column(2)-px*nnx)*nny + column(1)-py*nny
+
+            IF ( lastdist == 0._wp )  THEN
+               horz_entry = -HUGE(1._wp)
+            ELSE
+               horz_entry = (nzterr(ig) - origin(1)) / lastdist
+            ENDIF
+            horz_exit = (nzterr(ig) - origin(1)) / nextdist
+            horizon = MAX(horizon, horz_entry, horz_exit)
+
+            IF ( plant_canopy )  THEN
+               rt2_track(:, ntrack) = column(:)
+               rt2_track_dist(ntrack) = nextdist
+            ENDIF
+         ENDIF
+
+         IF ( nextdist >= distance )  EXIT
+         lastdist = nextdist
+         dimnext(seldim) = dimnext(seldim) + dimdelta(seldim)
+         dimnextdist(seldim) = (dimnext(seldim) - .5_wp - yxorigin(seldim)) / yxdir(seldim)
+      ENDDO
+
+      IF ( plant_canopy )  THEN
+         !--Request LAD WHERE applicable
+         !--
+#if defined( __parallel )
+         IF ( rma_lad_raytrace )  THEN
+!--         send requests for lad_s to appropriate processor
+            !CALL cpu_log( log_point_s(77), 'usm_init_rma', 'start' )
+            DO i = 1, ntrack
+               px = rt2_track(2,i)/nnx
+               py = rt2_track(1,i)/nny
+               ip = px*pdims(2)+py
+               ig = ip*nnx*nny + (rt2_track(2,i)-px*nnx)*nny + rt2_track(1,i)-py*nny
+               IF ( plantt(ig) <= nzterr(ig) )  CYCLE
+               wdisp = (rt2_track(2,i)-px*nnx)*(nny*nzu) + (rt2_track(1,i)-py*nny)*nzu + nzterr(ig)+1-nzub
+               wcount = plantt(ig)-nzterr(ig)
+               ! TODO send request ASAP - even during raytracing
+               CALL MPI_Get(rt2_track_lad(nzterr(ig)+1:plantt(ig), i), wcount, MPI_REAL, ip,    &
+                            wdisp, wcount, MPI_REAL, win_lad, ierr)
+               IF ( ierr /= 0 )  THEN
+                  WRITE(message_string, *) 'MPI error ', ierr, ' at MPI_Get'
+                  CALL message( 'raytrace_2d', 'PA0526', 1, 2, 0, 6, 0 )
+               ENDIF
+            ENDDO
+
+!--         wait for all pending local requests complete
+            ! TODO WAIT selectively for each column later when needed
+            CALL MPI_Win_flush_local_all(win_lad, ierr)
+            IF ( ierr /= 0 )  THEN
+               WRITE(message_string, *) 'MPI error ', ierr, ' at MPI_Win_flush_local_all'
+               CALL message( 'raytrace', 'PA0527', 1, 2, 0, 6, 0 )
+            ENDIF
+            !CALL cpu_log( log_point_s(77), 'usm_init_rma', 'stop' )
+         ELSE ! rma_lad_raytrace
+            DO i = 1, ntrack
+               px = rt2_track(2,i)/nnx
+               py = rt2_track(1,i)/nny
+               ip = px*pdims(2)+py
+               ig = ip*nnx*nny*nzu + (rt2_track(2,i)-px*nnx)*(nny*nzu) + (rt2_track(1,i)-py*nny)*nzu
+               rt2_track_lad(nzub:plantt_max, i) = sub_lad_g(ig:ig+nly-1)
+            ENDDO
+         ENDIF
+#else
+         DO i = 1, ntrack
+            rt2_track_lad(nzub:plantt_max, i) = sub_lad(rt2_track(1,i), rt2_track(2,i), nzub:plantt_max)
+         ENDDO
+#endif
+
+         !--Skip the PCB around origin if requested
+         !--
+         IF ( skip_1st_pcb )  THEN
+            rt2_track_lad(NINT(origin(1), iwp), 1) = 0._wp
+         ENDIF
+
+         !--Assert that we have space allocated for CSFs
+         !--
+         maxboxes = (ntrack + MAX(origin(1) - nzub, nzut - origin(1))) * SIZE(zdirs, 1)
+         IF ( ncsfl + maxboxes > ncsfla )  THEN
+!--         use this code for growing by fixed exponential increments (equivalent to case where ncsfl always increases by 1)
+!--         k = CEILING(grow_factor ** real(CEILING(log(real(ncsfl + maxboxes, kind=wp)) &
+!--                                                / log(grow_factor)), kind=wp))
+!--         or use this code to simply always keep some extra space after growing
+            k = CEILING(REAL(ncsfl + maxboxes, kind=wp) * grow_factor)
+            CALL merge_and_grow_csf(k)
+         ENDIF
+
+         !--Calculate transparencies and store new CSFs
+         !--
+         zbottom = REAL(nzub, wp) - .5_wp
+         ztop = REAL(plantt_max, wp) + .5_wp
+
+         !--Reverse direction of radiation (face->sky), only when create_csf
+         !--
+         IF ( create_csf )  THEN
+            DO i = 1, ntrack ! for each column
+               dxxyy = ((dy*yxdir(1))**2 + (dx*yxdir(2))**2) * (rt2_track_dist(i)-rt2_track_dist(i-1))**2
+               px = rt2_track(2,i)/nnx
+               py = rt2_track(1,i)/nny
+               ip = px*pdims(2)+py
+
+               DO k = LBOUND(zdirs, 1), UBOUND(zdirs, 1) ! for each ray
+                  IF ( zdirs(k) <= horizon )  THEN
+                     CYCLE
+                  ENDIF
+
+                  zorig = REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i-1)
+                  IF ( zorig <= zbottom .OR. zorig >= ztop )  CYCLE
+
+                  zsgn = INT(SIGN(1._wp, zdirs(k)), iwp)
+                  rt2_dist(1) = 0._wp
+                  IF ( zdirs(k) == 0._wp )  THEN ! ray is exactly horizontal
+                     nz = 2
+                     rt2_dist(nz) = SQRT(dxxyy)
+                     iz = NINT(zorig, iwp)
+                  ELSE
+                     zexit = MIN(MAX(REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
+
+                     zb0 = FLOOR(  zorig * zsgn - .5_wp) + 1  ! because it must be greater than orig
+                     zb1 = CEILING(zexit * zsgn - .5_wp) - 1  ! because it must be smaller than exit
+                     nz = MAX(zb1 - zb0 + 3, 2)
+                     rt2_dist(nz) = SQRT(((zexit-zorig)*dz)**2 + dxxyy)
+                     qdist = rt2_dist(nz) / (zexit-zorig)
+                     rt2_dist(2:nz-1) = (/( ((REAL(l, wp) + .5_wp) * zsgn - zorig) * qdist , l = zb0, zb1 )/)
+                     iz = zb0 * zsgn
+                  ENDIF
+
+                  DO l = 2, nz
+                     IF ( rt2_track_lad(iz, i) > 0._wp )  THEN
+                        curtrans = exp(-ext_coef * rt2_track_lad(iz, i) * (rt2_dist(l)-rt2_dist(l-1)))
+
+                        ncsfl = ncsfl + 1
+                        acsf(ncsfl)%ip = ip
+                        acsf(ncsfl)%itx = rt2_track(2,i)
+                        acsf(ncsfl)%ity = rt2_track(1,i)
+                        acsf(ncsfl)%itz = iz
+                        acsf(ncsfl)%isurfs = iorig
+                        acsf(ncsfl)%rsvf = REAL((1._wp - curtrans)*aorig*vffrac(k), wp) ! we postpone multiplication by transparency
+                        acsf(ncsfl)%rtransp = REAL(transparency(k), wp)
+
+                        transparency(k) = transparency(k) * curtrans
+                     ENDIF
+                     iz = iz + zsgn
+                  ENDDO ! l = 1, nz - 1
+               ENDDO ! k = LBOUND(zdirs, 1), UBOUND(zdirs, 1)
+            ENDDO ! i = 1, ntrack
+
+            transparency(:) = 1._wp !-- Reset all rays to transparent
+         ENDIF
+
+         !-- Forward direction of radiation (sky->face), always
+         !--
+         DO i = ntrack, 1, -1 ! for each column backwards
+            dxxyy = ((dy*yxdir(1))**2 + (dx*yxdir(2))**2) * (rt2_track_dist(i)-rt2_track_dist(i-1))**2
+            px = rt2_track(2,i)/nnx
+            py = rt2_track(1,i)/nny
+            ip = px*pdims(2)+py
+
+            DO k = LBOUND(zdirs, 1), UBOUND(zdirs, 1) ! for each ray
+               IF ( zdirs(k) <= horizon )  THEN
+                  transparency(k) = 0._wp
+                  CYCLE
+               ENDIF
+
+               zexit = REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i-1)
+               IF ( zexit <= zbottom .OR. zexit >= ztop )  CYCLE
+
+               zsgn = -INT(SIGN(1._wp, zdirs(k)), iwp)
+               rt2_dist(1) = 0._wp
+               IF ( zdirs(k) == 0._wp )  THEN ! ray is exactly horizontal
+                  nz = 2
+                  rt2_dist(nz) = SQRT(dxxyy)
+                  iz = NINT(zexit, iwp)
+               ELSE
+                  zorig = MIN(MAX(REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
+
+                  zb0 = FLOOR(  zorig * zsgn - .5_wp) + 1  ! because it must be greater than orig
+                  zb1 = CEILING(zexit * zsgn - .5_wp) - 1  ! because it must be smaller than exit
+                  nz = MAX(zb1 - zb0 + 3, 2)
+                  rt2_dist(nz) = SQRT(((zexit-zorig)*dz)**2 + dxxyy)
+                  qdist = rt2_dist(nz) / (zexit-zorig)
+                  rt2_dist(2:nz-1) = (/( ((REAL(l, wp) + .5_wp) * zsgn - zorig) * qdist , l = zb0, zb1 )/)
+                  iz = zb0 * zsgn
+               ENDIF
+
+               DO l = 2, nz
+                  IF ( rt2_track_lad(iz, i) > 0._wp )  THEN
+                     curtrans = exp(-ext_coef * rt2_track_lad(iz, i) * (rt2_dist(l)-rt2_dist(l-1)))
+
+                     IF ( create_csf )  THEN
+                        ncsfl = ncsfl + 1
+                        acsf(ncsfl)%ip = ip
+                        acsf(ncsfl)%itx = rt2_track(2,i)
+                        acsf(ncsfl)%ity = rt2_track(1,i)
+                        acsf(ncsfl)%itz = iz
+                        acsf(ncsfl)%isurfs = -1 ! a special ID indicating sky
+                        acsf(ncsfl)%rsvf = REAL((1._wp - curtrans)*aorig*vffrac(k), wp) ! we postpone multiplication by transparency
+                        acsf(ncsfl)%rtransp = REAL(transparency(k), wp)
+                     ENDIF  !< create_csf
+
+                     transparency(k) = transparency(k) * curtrans
+                  ENDIF
+                  iz = iz + zsgn
+               ENDDO ! l = 1, nz - 1
+            ENDDO ! k = LBOUND(zdirs, 1), UBOUND(zdirs, 1)
+         ENDDO ! i = 1, ntrack
+
+      ELSE ! not plant_canopy
+         DO k = UBOUND(zdirs, 1), LBOUND(zdirs, 1), -1 ! TODO make more generic
+            IF ( zdirs(k) > horizon )  EXIT
+            transparency(k) = 0._wp
+         ENDDO
+      ENDIF
+
+   END SUBROUTINE raytrace_2d
+ 
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Calculates apparent solar positions for all timesteps and stores discretized
+!> positions.
+!------------------------------------------------------------------------------!
+   SUBROUTINE radiation_presimulate_solar_pos
+      IMPLICIT NONE
+
+      INTEGER(iwp)                              ::  it, i, j
+      REAL(wp)                                  ::  tsrp_prev
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  dsidir_tmp       !< dsidir_tmp[:,i] = unit vector of i-th
+                                                                     !< appreant solar direction
+
+      ALLOCATE ( dsidir_rev(0:raytrace_discrete_elevs/2-1,                 &
+                            0:raytrace_discrete_azims-1) )
+      dsidir_rev(:,:) = -1
+      ALLOCATE ( dsidir_tmp(3,                                             &
+                     raytrace_discrete_elevs/2*raytrace_discrete_azims) )
+      ndsidir = 0
+
+!
+!--   We will artificialy update time_since_reference_point and return to
+!--   true value later
+      tsrp_prev = time_since_reference_point
+      sun_direction = .TRUE.
+
+!
+!--   Process spinup time if configured
+      IF ( spinup_time > 0._wp )  THEN
+         DO  it = 0, CEILING(spinup_time / dt_spinup)
+            time_since_reference_point = -spinup_time + REAL(it, wp) * dt_spinup
+            CALL simulate_pos
+         ENDDO
+      ENDIF
+!
+!--   Process simulation time
+      DO  it = 0, CEILING(end_time / dt_radiation)
+         time_since_reference_point = REAL(it, wp) * dt_radiation
+         CALL simulate_pos
+      ENDDO
+
+      time_since_reference_point = tsrp_prev
+
+!--   Allocate global vars which depend on ndsidir
+      ALLOCATE ( dsidir ( 3, ndsidir ) )
+      dsidir(:,:) = dsidir_tmp(:, 1:ndsidir)
+      DEALLOCATE ( dsidir_tmp )
+      ALLOCATE ( dsitrans(nsurfl, ndsidir) )
+      ALLOCATE ( dsitransc(npcbl, ndsidir) )
+
+      WRITE ( message_string, * ) 'Precalculated', ndsidir, ' solar positions', &
+                                  'from', it, ' timesteps.'
+      CALL message( 'radiation_presimulate_solar_pos', 'UI0013', 0, 0, 0, 6, 0 )
+
+      CONTAINS
+
+      !------------------------------------------------------------------------!
+      ! Description:
+      ! ------------
+      !> Simuates a single position
+      !------------------------------------------------------------------------!
+      SUBROUTINE simulate_pos
+         IMPLICIT NONE
+!
+!--      Update apparent solar position based on modified t_s_r_p
+         CALL calc_zenith
+         IF ( zenith(0) > 0 )  THEN
+!--         
+!--         Identify solar direction vector (discretized number) 1)
+            i = MODULO(NINT(ATAN2(sun_dir_lon(0), sun_dir_lat(0))               &
+                            / (2._wp*pi) * raytrace_discrete_azims-.5_wp, iwp), &
+                       raytrace_discrete_azims)
+            j = FLOOR(ACOS(zenith(0)) / pi * raytrace_discrete_elevs)
+            IF ( dsidir_rev(j, i) == -1 )  THEN
+               ndsidir = ndsidir + 1
+               dsidir_tmp(:, ndsidir) =                                              &
+                     (/ COS((REAL(j,wp)+.5_wp) * pi      / raytrace_discrete_elevs), &
+                        SIN((REAL(j,wp)+.5_wp) * pi      / raytrace_discrete_elevs)  &
+                      * COS((REAL(i,wp)+.5_wp) * 2_wp*pi / raytrace_discrete_azims), &
+                        SIN((REAL(j,wp)+.5_wp) * pi      / raytrace_discrete_elevs)  &
+                      * SIN((REAL(i,wp)+.5_wp) * 2_wp*pi / raytrace_discrete_azims) /)
+               dsidir_rev(j, i) = ndsidir
+            ENDIF
+         ENDIF
+      END SUBROUTINE simulate_pos
+
+   END SUBROUTINE radiation_presimulate_solar_pos
+
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Determines whether two faces are oriented towards each other. Since the
+!> surfaces follow the gird box surfaces, it checks first whether the two surfaces
+!> are directed in the same direction, then it checks if the two surfaces are
 !> located in confronted direction but facing away from each other, e.g. <--| |-->
 !------------------------------------------------------------------------------!
@@ -6558,42 +6921,39 @@
         IF ( (d==iup_u  .OR.  d==iup_l  .OR.  d==iup_a )                             &
              .AND. (d2==iup_u  .OR. d2==iup_l) ) RETURN
-        IF ( (d==isky  .OR.  d==idown_a)  .AND.  d2==isky ) RETURN
-        IF ( (d==isouth_u  .OR.  d==isouth_l  .OR.  d==isouth_a  .OR.  d==inorth_b ) &
-             .AND.  (d2==isouth_u  .OR.  d2==isouth_l  .OR.  d2==inorth_b) ) RETURN
-        IF ( (d==inorth_u  .OR.  d==inorth_l  .OR.  d==inorth_a  .OR.  d==isouth_b ) &
-             .AND.  (d2==inorth_u  .OR.  d2==inorth_l  .OR.  d2==isouth_b) ) RETURN
-        IF ( (d==iwest_u  .OR.  d==iwest_l  .OR.  d==iwest_a  .OR.  d==ieast_b )     &
-             .AND.  (d2==iwest_u  .OR.  d2==iwest_l  .OR.  d2==ieast_b ) ) RETURN
-        IF ( (d==ieast_u  .OR.  d==ieast_l  .OR.  d==ieast_a  .OR.  d==iwest_b )     &
-             .AND.  (d2==ieast_u  .OR.  d2==ieast_l  .OR.  d2==iwest_b ) ) RETURN
+        IF ( (d==isouth_u  .OR.  d==isouth_l  .OR.  d==isouth_a ) &
+             .AND.  (d2==isouth_u  .OR.  d2==isouth_l) ) RETURN
+        IF ( (d==inorth_u  .OR.  d==inorth_l  .OR.  d==inorth_a ) &
+             .AND.  (d2==inorth_u  .OR.  d2==inorth_l) ) RETURN
+        IF ( (d==iwest_u  .OR.  d==iwest_l  .OR.  d==iwest_a )     &
+             .AND.  (d2==iwest_u  .OR.  d2==iwest_l ) ) RETURN
+        IF ( (d==ieast_u  .OR.  d==ieast_l  .OR.  d==ieast_a )     &
+             .AND.  (d2==ieast_u  .OR.  d2==ieast_l ) ) RETURN
 
 !-- second check: are surfaces facing away from each other
         SELECT CASE (d)
-            CASE (iup_u, iup_l, iup_a)                    !< upward facing surfaces
+            CASE (iup_u, iup_l, iup_a)              !< upward facing surfaces
                 IF ( z2 < z ) RETURN
-            CASE (isky, idown_a)                          !< downward facing surfaces
+            CASE (idown_a)                          !< downward facing surfaces
                 IF ( z2 > z ) RETURN
-            CASE (isouth_u, isouth_l, isouth_a, inorth_b) !< southward facing surfaces
+            CASE (isouth_u, isouth_l, isouth_a)     !< southward facing surfaces
                 IF ( y2 > y ) RETURN
-            CASE (inorth_u, inorth_l, inorth_a, isouth_b) !< northward facing surfaces
+            CASE (inorth_u, inorth_l, inorth_a)     !< northward facing surfaces
                 IF ( y2 < y ) RETURN
-            CASE (iwest_u, iwest_l, iwest_a, ieast_b)     !< westward facing surfaces
+            CASE (iwest_u, iwest_l, iwest_a)        !< westward facing surfaces
                 IF ( x2 > x ) RETURN
-            CASE (ieast_u, ieast_l, ieast_a, iwest_b)     !< eastward facing surfaces
+            CASE (ieast_u, ieast_l, ieast_a)        !< eastward facing surfaces
                 IF ( x2 < x ) RETURN
         END SELECT
 
         SELECT CASE (d2)
-            CASE (iup_u)                        !< ground, roof
+            CASE (iup_u)                            !< ground, roof
                 IF ( z < z2 ) RETURN
-            CASE (isky)                         !< sky
-                IF ( z > z2 ) RETURN
-            CASE (isouth_u, isouth_l, inorth_b) !< south facing
+            CASE (isouth_u, isouth_l)               !< south facing
                 IF ( y > y2 ) RETURN
-            CASE (inorth_u, inorth_l, isouth_b) !< north facing
+            CASE (inorth_u, inorth_l)               !< north facing
                 IF ( y < y2 ) RETURN
-            CASE (iwest_u, iwest_l, ieast_b)    !< west facing
+            CASE (iwest_u, iwest_l)                 !< west facing
                 IF ( x > x2 ) RETURN
-            CASE (ieast_u, ieast_l, iwest_b)    !< east facing
+            CASE (ieast_u, ieast_l)                 !< east facing
                 IF ( x < x2 ) RETURN
             CASE (-1)
@@ -6604,4 +6964,5 @@
         
     END FUNCTION surface_facing
+
 
 !------------------------------------------------------------------------------!
@@ -6613,12 +6974,12 @@
     SUBROUTINE radiation_read_svf
 
-       IMPLICIT NONE
-       INTEGER(iwp)                 :: fsvf = 88
-       INTEGER(iwp)                 :: i
-       CHARACTER(usm_version_len)   :: usm_version_field
-       CHARACTER(svf_code_len)      :: svf_code_field
-
-       DO  i = 0, io_blocks-1
-          IF ( i == io_group )  THEN
+        IMPLICIT NONE
+        INTEGER(iwp)                 :: fsvf = 88
+        INTEGER(iwp)                 :: i
+        CHARACTER(rad_version_len)   :: rad_version_field
+        CHARACTER(svf_code_len)      :: svf_code_field
+
+        DO  i = 0, io_blocks-1
+            IF ( i == io_group )  THEN
 
 !
@@ -6626,52 +6987,53 @@
              CALL check_open( fsvf )
 
-
-!--          read and check version
-             READ ( fsvf ) usm_version_field
-             IF ( TRIM(usm_version_field) /= TRIM(usm_version) )  THEN
-                 WRITE( message_string, * ) 'Version of binary SVF file "',           &
-                                         TRIM(usm_version_field), '" does not match ',            &
-                                         'the version of model "', TRIM(usm_version), '"'
-                 CALL message( 'radiation_read_svf', 'PA0482', 1, 2, 0, 6, 0 )
-             ENDIF
+!--             read and check version
+                READ ( fsvf ) rad_version_field
+                IF ( TRIM(rad_version_field) /= TRIM(rad_version) )  THEN
+                    WRITE( message_string, * ) 'Version of binary SVF file "',           &
+                                TRIM(rad_version_field), '" does not match ',            &
+                                'the version of model "', TRIM(rad_version), '"'
+                    CALL message( 'radiation_read_svf', 'PA0482', 1, 2, 0, 6, 0 )
+                ENDIF
                 
-!--          read nsvfl, ncsfl
-             READ ( fsvf ) nsvfl, ncsfl
-             IF ( nsvfl <= 0  .OR.  ncsfl < 0 )  THEN
-                WRITE( message_string, * ) 'Wrong number of SVF or CSF'
-                CALL message( 'radiation_read_svf', 'PA0483', 1, 2, 0, 6, 0 )
-             ELSE
-                WRITE(message_string,*) '    Number of SVF and CSF to read', nsvfl, ncsfl
-                CALL location_message( message_string, .TRUE. )
-             ENDIF
+!--             read nsvfl, ncsfl
+                READ ( fsvf ) nsvfl, ncsfl, nsurfl
+                IF ( nsvfl <= 0  .OR.  ncsfl < 0 )  THEN
+                    WRITE( message_string, * ) 'Wrong number of SVF or CSF'
+                    CALL message( 'radiation_read_svf', 'PA0483', 1, 2, 0, 6, 0 )
+                ELSE
+                    WRITE(message_string,*) '    Number of SVF, CSF, and nsurfl to read '&
+                         , nsvfl, ncsfl, nsurfl
+                    CALL location_message( message_string, .TRUE. )
+                ENDIF
                 
-             ALLOCATE(svf(ndsvf,nsvfl))
-             ALLOCATE(svfsurf(idsvf,nsvfl))
-
-             READ(fsvf) svf
-             READ(fsvf) svfsurf
-
-             IF ( plant_canopy )  THEN
-                 ALLOCATE(csf(ndcsf,ncsfl))
-                 ALLOCATE(csfsurf(idcsf,ncsfl))
-                 READ(fsvf) csf
-                 READ(fsvf) csfsurf
-             ENDIF
-
-             READ ( fsvf ) svf_code_field
-             IF ( TRIM(svf_code_field) /= TRIM(svf_code) )  THEN
-                WRITE( message_string, * ) 'Wrong structure of binary svf file'
-                CALL message( 'radiation_read_svf', 'PA0484', 1, 2, 0, 6, 0 )
-             ENDIF
+                ALLOCATE(skyvf(nsurfl))
+                ALLOCATE(skyvft(nsurfl))
+                ALLOCATE(svf(ndsvf,nsvfl))
+                ALLOCATE(svfsurf(idsvf,nsvfl))
+                READ(fsvf) skyvf
+                READ(fsvf) skyvft
+                READ(fsvf) svf
+                READ(fsvf) svfsurf
+                IF ( plant_canopy )  THEN
+                    ALLOCATE(csf(ndcsf,ncsfl))
+                    ALLOCATE(csfsurf(idcsf,ncsfl))
+                    READ(fsvf) csf
+                    READ(fsvf) csfsurf
+                ENDIF
+                READ ( fsvf ) svf_code_field
                 
+                IF ( TRIM(svf_code_field) /= TRIM(svf_code) )  THEN
+                    WRITE( message_string, * ) 'Wrong structure of binary svf file'
+                    CALL message( 'radiation_read_svf', 'PA0484', 1, 2, 0, 6, 0 )
+                ENDIF       
 !
 !--          Close binary file                 
              CALL close_file( fsvf )
                 
-          ENDIF
+            ENDIF
 #if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
+            CALL MPI_BARRIER( comm2d, ierr )
 #endif
-       ENDDO
+        ENDDO
 
     END SUBROUTINE radiation_read_svf
